# SaseulJS - SASEUL Javascript Development Kit

[![NPM Version][npm-version-image]][npm-url]

[![NPM Install Size][npm-install-size-image]][npm-install-size-url]

[![NPM Downloads][npm-downloads-image]][npm-downloads-url]

# Release Note

- `2.7.0 ~` Compatible with SASEUL(`2.1.6 ~`)
- `< 2.6.10` Compatible with SASEUL(`< 2.1.5`)

# Overview

SaseulJS is a toolkit for developing decentralized applications based on the SASEUL blockchain engine.
You can use this toolkit to create and send transactions and requests to the SASEUL network.
You can also create and register smart contracts that operate on the SASEUL network.

If you need information about SASEUL, you can refer to the link below.

- SASEUL Website: https://saseul.com
- Guardee Wallet: https://applink.guardee.io/
- Block Explorer: https://explorer.saseul.com/

If you want to install the SASEUL engine, you can refer to the link below.

- Docker: https://hub.docker.com/r/artifriends/saseul-network

# Installation

You can install saseul-js via a package manager:

[NPM](https://www.npmjs.org/):

    $ npm install saseul

...or you can also use it as follows.

Browser:

    <!-- Dependencies: crypto-js, tweetnacl, axios -->
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/crypto-js/4.1.1/crypto-js.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/tweetnacl/1.0.2/nacl.min.js"></script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/axios/1.3.5/axios.min.js"></script>

    <script type="text/javascript" src="saseul.min.js"></script>

# Quick Start

    $ npm install saseul

# Documentation

See also: [SASEUL Docs](https://docs.saseul.com/)

# License

[GPL-3.0](LICENSE)

[npm-downloads-image]: https://badgen.net/npm/dm/saseul
[npm-downloads-url]: https://npmcharts.com/compare/saseul?minimal=true
[npm-install-size-image]: https://badgen.net/packagephobia/install/saseul
[npm-install-size-url]: https://packagephobia.com/result?p=saseul
[npm-url]: https://npmjs.org/package/saseul
[npm-version-image]: https://badgen.net/npm/v/saseul